LIESMICH zum Compiler Version 3.57            Stand: 03.02.92

Neue Features (ab Version 3.57):

- ein neues Steuerwort zum direkten Setzen der Headerflags in 
Programmdateien: "FLAGS XXXX". "XXXX" steht fr die hexadezimale 
Schreib-weise des reservierten Langworts, welches so in den 
Programmheader einge-tragen wird. Sie knnen somit alle 
Einstellungen, wie FASTLOAD, TT-RAM benutzen oder TPA-Gre 
bereits im Quelltext einstellen. Die genaue Aufschlsselung des 
Langworts entnehmen Sie bitte dem Beispiel-programm Flags im 
Ordner "DEMO\ATARI_TT\"

LIESMICH zum Compiler Version 3.56            Stand: 21.01.92

Beseitigte Fehler:

- ein Programm, welches Leerzeilen am Anfang enthielt, fhrte den Compiler 
in eine Endlosschleife.

- Programme mit der Funktion FRAC in einfacher Genauigkeit fhrten bei 
Verwendung der IO-FPU zum Absturz, wenn das Programm ge'cutlib't wurde.

- das Auftreten des Zeichens eins (CHR$(1)) schaltete auf ASCII-Ausgabe 
um, auch wenn es innerhalb einer ESC-Sequenz auftrat.


LIESMICH zum Compiler Version 3.55            Stand: 03.12.91

Beseitigte Fehler:

- Die VDI-Handler fr V_Opnvwk und V_Opnwk waren fehlerhaft, so da 
ein gleichzeitiges ffnen mehrerer Workstations (insbesondere auch einer 
Druckerworkstation) nicht funktionierte.

Zustzliche Features:

- Der Compiler ab Version 3.55 Realease 031291 untersttzt ebenso wie 
der Interpreter die neue kompatible Form des SCREEN-Befehls (nheres 
hierzu in der LIESMICH Datei des Interpreters)

LIESMICH zum Compiler Version 3.55            Stand: 21.11.91

Beseitigte Fehler:

- Die Auswertung eines String-Ausdrucks bei SELECT fhrte nicht zum 
selben Ergebnis wie im Interpreter (fr Strings mit Lnge grer eins).

- Die Behandlung der Verzeichnisse durch den Compiler war nicht korrekt. 
Wenn CUTLIB auf dem Compiler-Pfad (einstellbar im Interpreter) 
nachgestartet werden sollte, wurde die BAS/FPULIB nicht immer gefunden. 
Stattdessen wurde die BAS/FPULIB immer noch von "C:\" geladen. Dies ist 
jetzt nicht mehr erforderlich.

- Wenn zwischen Compilaten mit CHAIN hin- und hergewechselt wurde, trat 
ein seltsamer Fehler auf: Das VDI erzeugte seltsame Rckgabewerte bzw. 
strzte gleich ganz ab. Dieses Verhalten kann vermieden werden, wenn 
beim Wechsel mit CHAIN die virtuelle Workstation nicht geschlossen und 
wieder geffnet wird. Diese an sich vllig korrekten Aufrufe, die zum 
Freirumen des Speichers dienen, waren der Auslser der Abstrze - eine 
weitere Erklrung konnte leider nicht gefunden werden.
Wenn nun ohne Schlieen der WK gewechselt wird kann es sein, da das 
nachgeladene Programm, wenn es grer als das ursprngliche ist, eine 
Lcke im Speicher hinterlt. Dieser Nachteil ist leider nicht zu 
vermeiden, da das ffnen der WK eben einen kleinen Datenbereich anlegt, 
der das Basic-Programm vom restlichen Speicher trennt.

- Die Zuweisungs-Operatoren *= und /= haben, wenn rechts ein FLOAT und 
links ein INT stand, flschlicher Weise den FLOAT-Wert gleich auf INT 
gerundet, anstatt erst zu multiplizieren und dann zu runden.

- Die Zuweisungs-Operatoren *= und /= (bei Zweier-Potenz-Faktoren) und 
auch die Postfix-Operatoren *2 und /2 lieferten bei der Multiplikation 
bzw. Division mit 0 einen berlauf, wenn zu oft multipliziert/div. 
wurde. Der Spezialfall "mal Null" war versehentlich nicht bercksichtigt 
worden.

- nur FPU: Die Zeit-Parameter bei WAIT und bei ON TIMER wurden falsch 
berechnet, was zu unendlichen Wartezeiten fhren konnte.

- nur FPU: Die INT(LF) Routine war fr negative Zahlen fehlerhaft. Hier 
war leider ein uralter unentdeckter Bug versteckt, der selbst im alten 
FPU-Compiler enthalten war. INT( -1.69# ) lieferte beispielsweise -4. 
Hier wurde an einer Stelle versehentlich mit dem falschen Zahlenformat 
gerechnet.

- nur FPU: SORT sortierte FLOAT-Felder falsch. Die Vergleichsfunktionen, 
die SORT verwendete, arbeiteten nicht richtig mit einfachen- und 
doppeltgenauen Werten

- nur FPU: MAT INV hatte beim Normalisieren am Ende des Gauss-
Algorithmus eine falsche Konstante. Die Inverse wurde deshalb fast immer 
als Null-Matrix berechnet.

- Ein fataler Fehler steckte noch im der Potenzfunktion ("^") fr 
doppeltgenaue Zahlen und in der Vergleichsfunktion fr einfachgenaue 
Zahlen. Abhngig vom Wert waren hier falsche Ergebnisse mglich. Zwar 
auch nur ein Tipfehler in den Bibliotheken, aber leider mit fatalen 
Folgen.

- Zur bersetzungszeit berechnete Konstanten wie 1/0 beendeten den 
Compilerlauf mit "? Division by zero". Stattdessen wird nun eine 
"Warning" ausgegeben.

- Der Critical-Error-Handler, der, falls die Maus nicht sichtbar ist, 
den Mauszeiger einschaltet, war leider noch fehlerhaft. Dies konnte zu 
Abstrzen fhren, wenn z.B. bei nur einem Laufwerk zum Diskettenwechsel 
aufgefordert wurde.

- Neues Steuerwort "NO_CRITIC" verhindert die Installation eines eigenen 
Critical-Error-Handlers ganz. Da die Verwendung des eigenen Handlers 
nicht unbedingt erforderlich ist - man kann die Fehlerbox ja auch 
"blind" oder mit der Tastatur bedienen - kann der eigene Critical-
Handler nunmehr ganz abgeschaltet werden.

Hinweis fr FPU-Benutzer:
Wenn Sie mit Hilfe der Funktionen MKS$ und MKD$ Binr-Dateien erzeugen, 
sind die Dateien auf jeden Fall kompatibel zu Dateien, die nicht von 
FPU-Compilaten erzeugt wurden. Zwar verwenden die FPU-Compilate intern 
ein anderes Zahlenformat (siehe ZFORMAT.DOC auf dieser Diskette) wie die 
CPU-Compilate, dieses wird jedoch von MKS$ und MKD$ automatisch 
umgerechnet. Dasselbe gilt auch fr die Wandlung zurck mit CVD bzw. 
CVS, wenn die Datei wieder eingelesen wird.

***********************************************************************
*    An  dieser  Stelle  nocheinmal vielen Dank an unsere Kunden,     *
*    die  mit  Ihren umfangreichen Tests viel bei der Beseitigung     *
*    der  Fehler  mitgeholfen  haben.  Vielen  Dank auch fr Ihre     *
*    Geduld  bis  zum  Eintreffen der nchsten Version, die - wie     *
*    immer - natrlich nicht schnell genug fertig sein kann.          *
***********************************************************************

LIESMICH zum Compiler Version 3.54            Stand: 16.10.91

Beseitigte Fehler:

- Das Ermitteln von Funktions-Zeigern funktionierte in groen 
Programmen nicht ordnungsgem. Dieser Fehler war leider in 
kleineren Testprogrammen nicht auszumachen, wir danken daher 
unseren Kunden fr ihre Mitarbeit.

- Das Multitasking mit "ON MOUSEBUT" war im ge'cutlib'ten Zustand 
immer noch nicht funktionsfhig.

- Einzeilige Funktionsdefinitionen, welche keine Parameter 
besaen, erzeugten ab und an eine Endlosschleife beim bersetzen.

- SWAP mit Zeiger-Referenzen fhrte zu "SWAP type 
mismatch"

- Zeiger-Referenzen als Prozedure-Parameter konnten nicht als 
Rckgabe-Variable verwendet werden. Es wurde zwar ein Wert an die 
Prozedure transferiert, aber keiner zurckgegeben.

- Die Ausgabe von Steuerzeichen mittels CHR$(1) funktionierte 
nicht.


LIESMICH zum Compiler Version 3.53            Stand: 24.09.91

Beseitigte Fehler:
- Durch ein Versehen waren alle Konstanten im Coprozessor-
Compilaten falsch. Es wurde nicht das IEEE- sondern das OMIKRON-
Format erzeugt, mit dem die FPU leider nicht umgehen kann.
Dadurch wurden so ziemlich alle Ergebnisse falsch. Da sich dieser 
Fehler erst in der Endphase der Entwicklung eingeschlichen hatte, 
ist er leider nicht rechtzeitig aufgefallen. Wir bitten um 
Entschuldigung.

- Indirekte Funktionsaufrufe an Funktionen, die Wort-Parameter 
haben (z. B. FN Test( Wert% ) ) , wurden falsch bersetzt. Statt 
eines WORDs wurde immer ein LONG auf dem Stapel bergeben, so da 
kein vernpftiger Wert bei der Funktion ankam. Dieser Fehler 
rhrt von einem generellen Problem bei der Typen-
berprfung/Konvertierung bei indirekten Aufrufen her. Es ist 
nmlich nicht mglich, die Parametertypen der Funktion 
festzustellen.
ES GILT DESHALB AB V 3.53 FOLGENDE REGEL:
  Bei indirekten Aufrufen werden als WORD bergeben:
   1. Eine WORD Variable ( Beispiel: Wert% )
   2. Ein WORD-Feld-Element ( Beispiel: Feld%(Index) )
   3. Ein Ausdruck der mit CINT konvertiert wird.
      ( Beispiel: CINT( Feld!(Index) )
  Alles andere insbesondere auch Konstanten werden immer als LONG 
  bergeben. Man sollte also nach Mglichkeit ganz auf WORD-
  bergabe verzichten und die Funktion umdefinieren.

- Matrix Operationen beanspruchen zwischenzeitlich Speicher aus 
dem String-Garbage. Dieser Speicher wurde versehentlich nicht 
gleich wieder freigegeben, sondern erst bei der nchsten String-
Operation. Wenn nun lange keine String-Operation gemacht 
wurde, konnte dieser Fehler zu einem "OUT OF MEMORY" fhren.

- Wenn eine Funktionstaste mit dem Befehl "KEY" mit einem 
Ersatztext belegt war, erschien die Taste zustzlich auch ohne 
ASCII-Byte im Tastaturbuffer. KEY 1="A" und Druck auf F1 erzeugte 
einmal die F-Taste ohne ASCII-Code und einmal mit ASCII-Code fr 
"A". Ab V 3.53 werden alle F-Tasten, die nicht mit KEY definiert 
sind ganz normal ohne ASCII-Code gemeldet. Definierte F-Tasten 
erscheinen genau sooft, wie es die Lnge des Ersatztextes 
vorgibt.

- Whrend INPUT USING und INPUT ist jetzt - wie auch im 
Handbuch angegeben - Multitasking mit "ON TIMER ..." 
mglich, auch wenn der Modus "Multitasking Between Statements" 
eingeschaltet ist.

- Durch ein Versehen ist eine nderung der Library-Funktion zum 
Invertieren einer Matrix missglckt. Die Funktion arbeitet nun 
wieder wie man es erwartet.

- Wenn man die neuen Befehle SELECT CASE ... verwendet, so konnten sich 
auf Grund interner Ungereimtheiten schlimmer Abstrze ergeben. Diese 
Probleme sind nun behoben - SELECT CASE kann uneingeschrnkt verwendet 
werden.

Zustzliche Features:
- Auf vielfachen Wunsch wurde das Cursor-Flimmern, das die BIOS 
Ausgabe whrend INPUT USING erzeugt, umgangen. Der Cursor wird 
jetzt zeitweilig ausgeschaltet.

- Die Bewertung von konstanten Ausdrcken wurde um zwei 
Oepratoren erweitert: < und >
Hier noch einmal die gesamte Liste:
 * / + - SHL SHR +1 -1 *2 /2 () VZ  = AND OR PI < >

Durch die Fehler-Korrektur betroffene Dateien:
FPULIB35, BASLIB35 und COMPILER.PRG


LIESMICH zum Compiler Version 3.52          Stand: 02.09.91

Beseitigte Fehler:
- Die Systemvariablen W_CHAR und H_CHAR waren in COMPILATEN 
gegenber dem interpretierten Programm gerade vertauscht.

- durch einen Felder bei der Garbage Collection (String Speicher 
aufrumen) wurden alle vereinbarten FIELD Buffer gelscht. Wenn 
man z.B. zwei Random-Access-Dateien offen hatte, so konnte immer 
nur mit der zuletzt geffneten gearbeitet werden.

- die Ausgabe Tabulierung mit TAB() rckte immer ein Zeichen zu 
wenig vor

- LOCATE war im Interpreter und im Compilat nicht ganz kompatibel 
zur Vorgngerversion. In X Richtung wurde der Cursor ein Zeichen 
zu weit links positioniert.

- Konstante Ausdrcke wie "1+1" oder "1=2" werden seit der 
Version 3.51 bereits whrend der bersetzung bewertet (siehe 
unten). Leider hatte sich hier noch ein Fehler eingeschlichen, 
der immer dann zum Tragen kam, wenn solche konst. Ausdrcke in 
Vergleichen oder als Abbruchbedingungen fr Schleifen verwendet 
wurden.

- wenn die erste Zeile eines Basic-Programms leer war, blieb der 
Compiler in einer Endlosschleife stecken.

- die Berwertung der neuen Systemvariablen W_PIXEL, H_PIXEL, 
W_CHAR und H_CHAR zerstrten einen internen Merker fr das 
Stacklevel. Fhrt zu Abstrzen, wenn die genannten SysVars in 
komplizierten Ausdrcken oder z.B. als Argument fr DIM verwendet 
werden.

- der indirekte Funktionsaufruf funktionierte nicht fr Integer 
Word Funktionen (Postfix %).

Durch die Fehler-Korrektur betroffene Dateien:
FPULIB35, BASLIB35 und COMPILER.PRG

Wir hoffen, da durch diese erste grere Revision die meisten 
Fehler beseitigt wurden und danken hiermit all jenen unseren 
Kunden, die mitgeholfen haben, die Fehler ausfindig zu machen.

            VIELEN DANK          IHR OMIKRON. TEAM  02.09.91



LIESMICH zum Compiler Version 3.51          Stand: 07.08.91

- Beseitigte Fehler:
Leider war im Multitasking-Teil noch ein Fehler versteckt. Alle 
Multitasking-Befehle wie ON MOUSEBUT ... usw. funktionierten nur, 
wenn TRACE eingeschaltet war.
    Dadurch genderte Dateien: 'FPULIB35' und 'BASLIB35'.


Ab Version 3.51 einige zustzliche Fhigkeiten:

1. Die neue Version untersttzt alle Neuerungen des Interpreter 
3.5 und arbeitet daher uneingeschrnkt mit diesem zusammen. In 
der Version 3.5 die seit Anfang Juni ausgeliefert wurde, fehlten 
noch einige Dinge, da auch im Interpreter noch nicht alles 
endgltig war.

2. Der Compiler kennt Konstanten und konstante Ausdrcke:
Mit dem Compiler-Steuerwort "DEF_CONST" wird ein Konstanten 
Vereinbarungsteil eingeleitet. Dann folgen beliebig viele 
Zuweisungen an Einzel-Variablen (keine Felder). Danach folgt das 
Steuerwort "END_CONST". Die Konstantenvereinbarung mu immer am 
Anfang des Programms stehen. Der Compiler betrachtet nun alle im 
Vereinbarungsteil zugewiesenen Variablen als konstant und 
bewertet sie bereits whrend der bersetzung. Solche Konstanten 
drfen natrlich nur einmal zugewiesen werden.
Beispiel: siehe unten

3. Der Compiler kann berflssige THEN- oder ELSE-Zweige ganz aus 
dem Programm herausfallen lassen. berflssig ist was wegen einer 
konstant falschen Bedingung niemals ausgefhrt werden wrde. 
Durch diese Art der Bedingten Compilierung lassen sich im 
Zusammenarbeit mit oben genannten Konstanten z.B. Schalter 
einrichten, die verschiedene Programm Versionen erzeugen.
Das automatische Auslassen mu mit COMPILER "CONST_IF_EXCLUDE" 
oder COMPILER "CIE" aktiviert werden. Es kann mit 
"CONST_IF_INCLUDE" oder "CII" wieder deaktiviert werden.
WICHTIG: Wenn Sie in ihrem Programm bestimmte Teile mittels "IF 0 
THEN" bersprungen haben, sich aber innerhalb des THEN-Zweigs 
noch verwendbarer Code befindetet (z.B. eine PROCEDURE oder ein 
Label, welches angesprungen wird), so erzeugt das Auslassen 
natrlich einen Fehler. Verwenden Sie daher zu solchen Zwecken 
besser "GOTO" anstelle von "IF 0 THEN ...".
Beispiel: zu Punkt 2 und 3

0 ' Der COMPILER erkennt ab sofort konstante Ausdrcke und fat diese
1 ' bereits whrend der bersetzung zusammen.
2 ' Weiterhin ist es mglich dem Compiler SYMBOLISCHE KONSTANTEN bekannt
3 ' zu machen, die ebenfalls schon zum bersetzungszeitpunkt bewertet werden.
4 '
5 COMPILER "DEF_CONST"
6   Pi_Halbe#= PI /2#
7   Zwei_Pi#=2#* PI
8   Wm_Redraw=20'          Gem Konstanten fr Window-Handling
9   Wm_Topped=21
10 COMPILER "END_CONST"
11 '
12 DEF FN Grad_To_Rad#(Grad#)=Grad#/360#*Zwei_Pi#
13                               '  \-----------/
14                               '    wird sofort zusammengefat.
15 PRINT "Winkelumrechnung: 45 Grad sind ";
16 PRINT FN Grad_To_Rad#(45#);" im Bogenma."
17 '
18 ' Desweiteren ist bedingte Compilierung mglich. Das bedeutet, da ganze
19 ' Programmteile, die auf Grund einer konstant NICHT ERFLLTEN Bedingung
20 ' niemals aufgefhrt werden, bereits beim bersetzen rausfallen.
21 ' Beispiel: Verschiedene Programmversionen (lnderspezifisch oder Demovers.)
22 '
23 COMPILER "DEF_CONST"
24    Demo=0
25    Englisch=1
26    Deutsch=2
27    Franz=3
28    Sprache=Deutsch
29 COMPILER "END_CONST"
30 '
31 COMPILER "CIE"' IF's werden gekrzt
32 IF Demo THEN
33   MOUSEON
34   FORM_ALERT (1,"[1][Abspeichern ist in der|Demoversion leider nicht|vorgesehen!][Abbruch]")
35   MOUSEOFF
36 ELSE
37   MOUSEON
38   FORM_ALERT (1,"[2][Wollen Sie wirklich|sichern ?][Sichern|Abbruch]")
39   MOUSEOFF
40 ENDIF
41 '
42 ' Je nach dem Wert der Konstanten 'Demo' wird hier entweder nur der THEN- oder
43 ' nur der ELSE-Teil bersetzt. Die andere Hlfte (und der Vergleich selbst)
44 ' fllt ganz raus.
45 '
46 IF Sprache=Deutsch THEN PRINT "Hallo !! Dies ist Demoprogramm"
47 IF Sprache=Englisch THEN PRINT "Hello !! This is a demo-program"
48 IF Sprache=Franz THEN PRINT "Salut !! C'est un logiciel de dmonstration"
49 '
50 ' Der Compiler bersetzt immer nur eine der drei Alternativen.
51 '
52 A$= INPUT$(1)
53
LIESMICH zum OMIKRON.Compiler Version 3.5    Stand: 21.06.91

Hinweise zum Compiler 3.5 (im Handbuch nicht ausdrcklich erwhnt):

- beim Programmstart ist der Cursor bei einem '.PRG'-Programm (und 
  solche erzeugt der Compiler normalerweise) immer ausgeschaltet.
  Wer also den Cursor sehen mchte sollte ihn immer explizit 
  einschalten: ' PRINT CHR$(27);"e"; '.

- Wer Funktionstasten mit 'INKEY$' oder 'INPUT USING' abfragen mchte, 
  braucht diese im Compilat nicht mehr mit 'KEY = ...' vorzubelegen. Der 
  Scancode der Taste wird in jedem Fall geliefert.

- Beseitigte Fehler:
    - Fehler bei 'CHAIN'  19.06.91
    - Fehler bei 'RUN "TEST.PRG '  19.06.91
    Dadurch genderte Dateien: 'FPULIB35' und 'BASLIB35'.

